
_lcd_cmd:

;LCD_2x16_74LS174.c,7 :: 		void lcd_cmd(char letter)
;LCD_2x16_74LS174.c,11 :: 		temp = temp>>4;
	MOVF       FARG_lcd_cmd_letter+0, 0
	MOVWF      FARG_lcd_nybble_nyb+0
	RRF        FARG_lcd_nybble_nyb+0, 1
	BCF        FARG_lcd_nybble_nyb+0, 7
	RRF        FARG_lcd_nybble_nyb+0, 1
	BCF        FARG_lcd_nybble_nyb+0, 7
	RRF        FARG_lcd_nybble_nyb+0, 1
	BCF        FARG_lcd_nybble_nyb+0, 7
	RRF        FARG_lcd_nybble_nyb+0, 1
	BCF        FARG_lcd_nybble_nyb+0, 7
;LCD_2x16_74LS174.c,12 :: 		lcd_nybble(temp,0);
	CLRF       FARG_lcd_nybble_rs+0
	CALL       _lcd_nybble+0
;LCD_2x16_74LS174.c,14 :: 		temp = temp&0x0f;
	MOVLW      15
	ANDWF      FARG_lcd_cmd_letter+0, 0
	MOVWF      FARG_lcd_nybble_nyb+0
;LCD_2x16_74LS174.c,15 :: 		lcd_nybble(temp,0);
	CLRF       FARG_lcd_nybble_rs+0
	CALL       _lcd_nybble+0
;LCD_2x16_74LS174.c,16 :: 		}
L_end_lcd_cmd:
	RETURN
; end of _lcd_cmd

_lcd_char:

;LCD_2x16_74LS174.c,18 :: 		void lcd_char(char letter)
;LCD_2x16_74LS174.c,22 :: 		temp = temp >> 4;
	MOVF       FARG_lcd_char_letter+0, 0
	MOVWF      FARG_lcd_nybble_nyb+0
	RRF        FARG_lcd_nybble_nyb+0, 1
	BCF        FARG_lcd_nybble_nyb+0, 7
	RRF        FARG_lcd_nybble_nyb+0, 1
	BCF        FARG_lcd_nybble_nyb+0, 7
	RRF        FARG_lcd_nybble_nyb+0, 1
	BCF        FARG_lcd_nybble_nyb+0, 7
	RRF        FARG_lcd_nybble_nyb+0, 1
	BCF        FARG_lcd_nybble_nyb+0, 7
;LCD_2x16_74LS174.c,23 :: 		lcd_nybble(temp,1);
	MOVLW      1
	MOVWF      FARG_lcd_nybble_rs+0
	CALL       _lcd_nybble+0
;LCD_2x16_74LS174.c,25 :: 		temp = temp & 0x0f;
	MOVLW      15
	ANDWF      FARG_lcd_char_letter+0, 0
	MOVWF      FARG_lcd_nybble_nyb+0
;LCD_2x16_74LS174.c,26 :: 		lcd_nybble(temp,1);
	MOVLW      1
	MOVWF      FARG_lcd_nybble_rs+0
	CALL       _lcd_nybble+0
;LCD_2x16_74LS174.c,27 :: 		}
L_end_lcd_char:
	RETURN
; end of _lcd_char

_lcd_nybble:

;LCD_2x16_74LS174.c,29 :: 		void lcd_nybble(char nyb, char rs)
;LCD_2x16_74LS174.c,32 :: 		DATA = 0;                   //clear the 174
	BCF        RB1_bit+0, BitPos(RB1_bit+0)
;LCD_2x16_74LS174.c,33 :: 		for(i=0;i<6;i++){           //repeat for 6 bits
	CLRF       lcd_nybble_i_L0+0
	CLRF       lcd_nybble_i_L0+1
L_lcd_nybble0:
	MOVLW      128
	XORWF      lcd_nybble_i_L0+1, 0
	MOVWF      R0+0
	MOVLW      128
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__lcd_nybble38
	MOVLW      6
	SUBWF      lcd_nybble_i_L0+0, 0
L__lcd_nybble38:
	BTFSC      STATUS+0, 0
	GOTO       L_lcd_nybble1
;LCD_2x16_74LS174.c,34 :: 		CLOCK=1;delay_us(50);CLOCK=0;        //write 0's to the 174
	BSF        RB0_bit+0, BitPos(RB0_bit+0)
	MOVLW      33
	MOVWF      R13+0
L_lcd_nybble3:
	DECFSZ     R13+0, 1
	GOTO       L_lcd_nybble3
	BCF        RB0_bit+0, BitPos(RB0_bit+0)
;LCD_2x16_74LS174.c,33 :: 		for(i=0;i<6;i++){           //repeat for 6 bits
	INCF       lcd_nybble_i_L0+0, 1
	BTFSC      STATUS+0, 2
	INCF       lcd_nybble_i_L0+1, 1
;LCD_2x16_74LS174.c,35 :: 		}
	GOTO       L_lcd_nybble0
L_lcd_nybble1:
;LCD_2x16_74LS174.c,36 :: 		DATA=1;                     //output the AND value
	BSF        RB1_bit+0, BitPos(RB1_bit+0)
;LCD_2x16_74LS174.c,37 :: 		CLOCK=1;delay_us(50);CLOCK=0;
	BSF        RB0_bit+0, BitPos(RB0_bit+0)
	MOVLW      33
	MOVWF      R13+0
L_lcd_nybble4:
	DECFSZ     R13+0, 1
	GOTO       L_lcd_nybble4
	BCF        RB0_bit+0, BitPos(RB0_bit+0)
;LCD_2x16_74LS174.c,38 :: 		DATA=rs;                    //output the RS bit value
	BTFSC      FARG_lcd_nybble_rs+0, 0
	GOTO       L__lcd_nybble39
	BCF        RB1_bit+0, BitPos(RB1_bit+0)
	GOTO       L__lcd_nybble40
L__lcd_nybble39:
	BSF        RB1_bit+0, BitPos(RB1_bit+0)
L__lcd_nybble40:
;LCD_2x16_74LS174.c,39 :: 		CLOCK=1;delay_us(50);CLOCK=0;
	BSF        RB0_bit+0, BitPos(RB0_bit+0)
	MOVLW      33
	MOVWF      R13+0
L_lcd_nybble5:
	DECFSZ     R13+0, 1
	GOTO       L_lcd_nybble5
	BCF        RB0_bit+0, BitPos(RB0_bit+0)
;LCD_2x16_74LS174.c,40 :: 		for(i=0;i<4;i++){           //output the nybble
	CLRF       lcd_nybble_i_L0+0
	CLRF       lcd_nybble_i_L0+1
L_lcd_nybble6:
	MOVLW      128
	XORWF      lcd_nybble_i_L0+1, 0
	MOVWF      R0+0
	MOVLW      128
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__lcd_nybble41
	MOVLW      4
	SUBWF      lcd_nybble_i_L0+0, 0
L__lcd_nybble41:
	BTFSC      STATUS+0, 0
	GOTO       L_lcd_nybble7
;LCD_2x16_74LS174.c,41 :: 		if((nyb & 0x08) != 0)
	MOVLW      8
	ANDWF      FARG_lcd_nybble_nyb+0, 0
	MOVWF      R1+0
	MOVF       R1+0, 0
	XORLW      0
	BTFSC      STATUS+0, 2
	GOTO       L_lcd_nybble9
;LCD_2x16_74LS174.c,42 :: 		DATA=1;
	BSF        RB1_bit+0, BitPos(RB1_bit+0)
	GOTO       L_lcd_nybble10
L_lcd_nybble9:
;LCD_2x16_74LS174.c,44 :: 		DATA=0;
	BCF        RB1_bit+0, BitPos(RB1_bit+0)
L_lcd_nybble10:
;LCD_2x16_74LS174.c,45 :: 		CLOCK=1;delay_us(50);CLOCK=0;
	BSF        RB0_bit+0, BitPos(RB0_bit+0)
	MOVLW      33
	MOVWF      R13+0
L_lcd_nybble11:
	DECFSZ     R13+0, 1
	GOTO       L_lcd_nybble11
	BCF        RB0_bit+0, BitPos(RB0_bit+0)
;LCD_2x16_74LS174.c,46 :: 		nyb=nyb<<1;
	RLF        FARG_lcd_nybble_nyb+0, 1
	BCF        FARG_lcd_nybble_nyb+0, 0
;LCD_2x16_74LS174.c,40 :: 		for(i=0;i<4;i++){           //output the nybble
	INCF       lcd_nybble_i_L0+0, 1
	BTFSC      STATUS+0, 2
	INCF       lcd_nybble_i_L0+1, 1
;LCD_2x16_74LS174.c,47 :: 		}
	GOTO       L_lcd_nybble6
L_lcd_nybble7:
;LCD_2x16_74LS174.c,48 :: 		e_togg();
	CALL       _e_togg+0
;LCD_2x16_74LS174.c,49 :: 		}
L_end_lcd_nybble:
	RETURN
; end of _lcd_nybble

_LCD_String_xy:

;LCD_2x16_74LS174.c,51 :: 		void LCD_String_xy (char row, char pos, char *str)  /* Send string to LCD function */
;LCD_2x16_74LS174.c,53 :: 		short i=0;
	CLRF       LCD_String_xy_i_L0+0
;LCD_2x16_74LS174.c,54 :: 		switch(row){
	GOTO       L_LCD_String_xy12
;LCD_2x16_74LS174.c,55 :: 		case 1:
L_LCD_String_xy14:
;LCD_2x16_74LS174.c,56 :: 		lcd_cmd(0x80);
	MOVLW      128
	MOVWF      FARG_lcd_cmd_letter+0
	CALL       _lcd_cmd+0
;LCD_2x16_74LS174.c,57 :: 		break;
	GOTO       L_LCD_String_xy13
;LCD_2x16_74LS174.c,58 :: 		case 2:
L_LCD_String_xy15:
;LCD_2x16_74LS174.c,59 :: 		lcd_cmd(0xC0);
	MOVLW      192
	MOVWF      FARG_lcd_cmd_letter+0
	CALL       _lcd_cmd+0
;LCD_2x16_74LS174.c,60 :: 		break;
	GOTO       L_LCD_String_xy13
;LCD_2x16_74LS174.c,61 :: 		case 3:
L_LCD_String_xy16:
;LCD_2x16_74LS174.c,62 :: 		lcd_cmd(0x94);
	MOVLW      148
	MOVWF      FARG_lcd_cmd_letter+0
	CALL       _lcd_cmd+0
;LCD_2x16_74LS174.c,63 :: 		break;
	GOTO       L_LCD_String_xy13
;LCD_2x16_74LS174.c,64 :: 		case 4:
L_LCD_String_xy17:
;LCD_2x16_74LS174.c,65 :: 		lcd_cmd(0xD4);
	MOVLW      212
	MOVWF      FARG_lcd_cmd_letter+0
	CALL       _lcd_cmd+0
;LCD_2x16_74LS174.c,66 :: 		break;
	GOTO       L_LCD_String_xy13
;LCD_2x16_74LS174.c,67 :: 		}
L_LCD_String_xy12:
	MOVF       FARG_LCD_String_xy_row+0, 0
	XORLW      1
	BTFSC      STATUS+0, 2
	GOTO       L_LCD_String_xy14
	MOVF       FARG_LCD_String_xy_row+0, 0
	XORLW      2
	BTFSC      STATUS+0, 2
	GOTO       L_LCD_String_xy15
	MOVF       FARG_LCD_String_xy_row+0, 0
	XORLW      3
	BTFSC      STATUS+0, 2
	GOTO       L_LCD_String_xy16
	MOVF       FARG_LCD_String_xy_row+0, 0
	XORLW      4
	BTFSC      STATUS+0, 2
	GOTO       L_LCD_String_xy17
L_LCD_String_xy13:
;LCD_2x16_74LS174.c,69 :: 		for(i=1; i<pos; i++){
	MOVLW      1
	MOVWF      LCD_String_xy_i_L0+0
L_LCD_String_xy18:
	MOVLW      128
	BTFSC      LCD_String_xy_i_L0+0, 7
	MOVLW      127
	MOVWF      R0+0
	MOVLW      128
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__LCD_String_xy43
	MOVF       FARG_LCD_String_xy_pos+0, 0
	SUBWF      LCD_String_xy_i_L0+0, 0
L__LCD_String_xy43:
	BTFSC      STATUS+0, 0
	GOTO       L_LCD_String_xy19
;LCD_2x16_74LS174.c,70 :: 		lcd_char(32);
	MOVLW      32
	MOVWF      FARG_lcd_char_letter+0
	CALL       _lcd_char+0
;LCD_2x16_74LS174.c,69 :: 		for(i=1; i<pos; i++){
	INCF       LCD_String_xy_i_L0+0, 1
;LCD_2x16_74LS174.c,71 :: 		}
	GOTO       L_LCD_String_xy18
L_LCD_String_xy19:
;LCD_2x16_74LS174.c,72 :: 		while(*str)              // Write data to LCD up to null
L_LCD_String_xy21:
	MOVF       FARG_LCD_String_xy_str+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_LCD_String_xy22
;LCD_2x16_74LS174.c,74 :: 		lcd_char(*str);
	MOVF       FARG_LCD_String_xy_str+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      FARG_lcd_char_letter+0
	CALL       _lcd_char+0
;LCD_2x16_74LS174.c,75 :: 		str++;               // Increment buffer
	INCF       FARG_LCD_String_xy_str+0, 1
;LCD_2x16_74LS174.c,76 :: 		}
	GOTO       L_LCD_String_xy21
L_LCD_String_xy22:
;LCD_2x16_74LS174.c,78 :: 		return;
;LCD_2x16_74LS174.c,79 :: 		}
L_end_LCD_String_xy:
	RETURN
; end of _LCD_String_xy

_LCD_Char_xy:

;LCD_2x16_74LS174.c,81 :: 		void LCD_Char_xy (char row, char pos, char ch)  /* Send string to LCD function */
;LCD_2x16_74LS174.c,84 :: 		if((pos-1) == 0)   lcd_cmd(0x80 | (row-1));
	MOVLW      1
	SUBWF      FARG_LCD_Char_xy_pos+0, 0
	MOVWF      R1+0
	CLRF       R1+1
	BTFSS      STATUS+0, 0
	DECF       R1+1, 1
	MOVLW      0
	XORWF      R1+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__LCD_Char_xy45
	MOVLW      0
	XORWF      R1+0, 0
L__LCD_Char_xy45:
	BTFSS      STATUS+0, 2
	GOTO       L_LCD_Char_xy23
	DECF       FARG_LCD_Char_xy_row+0, 0
	MOVWF      R0+0
	MOVLW      128
	IORWF      R0+0, 0
	MOVWF      FARG_lcd_cmd_letter+0
	CALL       _lcd_cmd+0
	GOTO       L_LCD_Char_xy24
L_LCD_Char_xy23:
;LCD_2x16_74LS174.c,85 :: 		else  lcd_cmd(0x80 | 0x40 | (row-1));
	DECF       FARG_LCD_Char_xy_row+0, 0
	MOVWF      R0+0
	MOVLW      192
	IORWF      R0+0, 0
	MOVWF      FARG_lcd_cmd_letter+0
	CALL       _lcd_cmd+0
L_LCD_Char_xy24:
;LCD_2x16_74LS174.c,87 :: 		lcd_char(ch);  /* Call LCD data write */
	MOVF       FARG_LCD_Char_xy_ch+0, 0
	MOVWF      FARG_lcd_char_letter+0
	CALL       _lcd_char+0
;LCD_2x16_74LS174.c,89 :: 		}
L_end_LCD_Char_xy:
	RETURN
; end of _LCD_Char_xy

_lcd_init:

;LCD_2x16_74LS174.c,90 :: 		void lcd_init(void)
;LCD_2x16_74LS174.c,92 :: 		delay_ms(20);
	MOVLW      52
	MOVWF      R12+0
	MOVLW      241
	MOVWF      R13+0
L_lcd_init25:
	DECFSZ     R13+0, 1
	GOTO       L_lcd_init25
	DECFSZ     R12+0, 1
	GOTO       L_lcd_init25
	NOP
	NOP
;LCD_2x16_74LS174.c,93 :: 		lcd_nybble(0x03,0);
	MOVLW      3
	MOVWF      FARG_lcd_nybble_nyb+0
	CLRF       FARG_lcd_nybble_rs+0
	CALL       _lcd_nybble+0
;LCD_2x16_74LS174.c,94 :: 		delay_ms(5);
	MOVLW      13
	MOVWF      R12+0
	MOVLW      251
	MOVWF      R13+0
L_lcd_init26:
	DECFSZ     R13+0, 1
	GOTO       L_lcd_init26
	DECFSZ     R12+0, 1
	GOTO       L_lcd_init26
	NOP
	NOP
;LCD_2x16_74LS174.c,95 :: 		e_togg();
	CALL       _e_togg+0
;LCD_2x16_74LS174.c,96 :: 		delay_us(160);
	MOVLW      106
	MOVWF      R13+0
L_lcd_init27:
	DECFSZ     R13+0, 1
	GOTO       L_lcd_init27
	NOP
;LCD_2x16_74LS174.c,97 :: 		e_togg();
	CALL       _e_togg+0
;LCD_2x16_74LS174.c,98 :: 		delay_us(160);
	MOVLW      106
	MOVWF      R13+0
L_lcd_init28:
	DECFSZ     R13+0, 1
	GOTO       L_lcd_init28
	NOP
;LCD_2x16_74LS174.c,99 :: 		lcd_nybble(0x02,0);
	MOVLW      2
	MOVWF      FARG_lcd_nybble_nyb+0
	CLRF       FARG_lcd_nybble_rs+0
	CALL       _lcd_nybble+0
;LCD_2x16_74LS174.c,100 :: 		delay_us(160);
	MOVLW      106
	MOVWF      R13+0
L_lcd_init29:
	DECFSZ     R13+0, 1
	GOTO       L_lcd_init29
	NOP
;LCD_2x16_74LS174.c,101 :: 		lcd_cmd(0x28);                    //set 4-bit mode and 2 lines
	MOVLW      40
	MOVWF      FARG_lcd_cmd_letter+0
	CALL       _lcd_cmd+0
;LCD_2x16_74LS174.c,102 :: 		delay_us(160);
	MOVLW      106
	MOVWF      R13+0
L_lcd_init30:
	DECFSZ     R13+0, 1
	GOTO       L_lcd_init30
	NOP
;LCD_2x16_74LS174.c,103 :: 		lcd_cmd(0x10);                    //cursor move & shift left
	MOVLW      16
	MOVWF      FARG_lcd_cmd_letter+0
	CALL       _lcd_cmd+0
;LCD_2x16_74LS174.c,104 :: 		delay_us(160);
	MOVLW      106
	MOVWF      R13+0
L_lcd_init31:
	DECFSZ     R13+0, 1
	GOTO       L_lcd_init31
	NOP
;LCD_2x16_74LS174.c,105 :: 		lcd_cmd(0x06);                    //entry mode = increment
	MOVLW      6
	MOVWF      FARG_lcd_cmd_letter+0
	CALL       _lcd_cmd+0
;LCD_2x16_74LS174.c,106 :: 		delay_us(160);
	MOVLW      106
	MOVWF      R13+0
L_lcd_init32:
	DECFSZ     R13+0, 1
	GOTO       L_lcd_init32
	NOP
;LCD_2x16_74LS174.c,107 :: 		lcd_cmd(0x01);                    //clear display
	MOVLW      1
	MOVWF      FARG_lcd_cmd_letter+0
	CALL       _lcd_cmd+0
;LCD_2x16_74LS174.c,108 :: 		delay_us(160);
	MOVLW      106
	MOVWF      R13+0
L_lcd_init33:
	DECFSZ     R13+0, 1
	GOTO       L_lcd_init33
	NOP
;LCD_2x16_74LS174.c,109 :: 		Lcd_cmd(display_on); // Display ON Cursor OFF
	MOVLW      12
	MOVWF      FARG_lcd_cmd_letter+0
	CALL       _lcd_cmd+0
;LCD_2x16_74LS174.c,111 :: 		}
L_end_lcd_init:
	RETURN
; end of _lcd_init

_e_togg:

;LCD_2x16_74LS174.c,113 :: 		void e_togg(void)
;LCD_2x16_74LS174.c,115 :: 		DATA=1;
	BSF        RB1_bit+0, BitPos(RB1_bit+0)
;LCD_2x16_74LS174.c,116 :: 		delay_us(50);
	MOVLW      33
	MOVWF      R13+0
L_e_togg34:
	DECFSZ     R13+0, 1
	GOTO       L_e_togg34
;LCD_2x16_74LS174.c,117 :: 		DATA=0;
	BCF        RB1_bit+0, BitPos(RB1_bit+0)
;LCD_2x16_74LS174.c,118 :: 		}
L_end_e_togg:
	RETURN
; end of _e_togg
