#line 1 "C:/Users/Usuario/Documents/MikroC_pro_pic/74LS174/LCD_2x16_74LS174.c"
#line 1 "c:/users/usuario/documents/mikroc_pro_pic/74ls174/lcd_2x16_74ls174.h"
#line 24 "c:/users/usuario/documents/mikroc_pro_pic/74ls174/lcd_2x16_74ls174.h"
void lcd_init(void);
void lcd_cmd(char letter);
void lcd_char(char letter);
void lcd_nybble( char nyb, char rs);
void LCD_Char_xy(char row, char pos, char ch);
void LCD_String_xy (char row, char pos, char *str);
void e_togg(void);
#line 7 "C:/Users/Usuario/Documents/MikroC_pro_pic/74LS174/LCD_2x16_74LS174.c"
void lcd_cmd(char letter)
{
 char temp;
 temp = letter;
 temp = temp>>4;
 lcd_nybble(temp,0);
 temp = letter;
 temp = temp&0x0f;
 lcd_nybble(temp,0);
}

void lcd_char(char letter)
{
 char temp;
 temp = letter;
 temp = temp >> 4;
 lcd_nybble(temp,1);
 temp = letter;
 temp = temp & 0x0f;
 lcd_nybble(temp,1);
}

void lcd_nybble(char nyb, char rs)
{
 int i;
  RB1_bit  = 0;
 for(i=0;i<6;i++){
  RB0_bit =1;delay_us(50); RB0_bit =0;
 }
  RB1_bit =1;
  RB0_bit =1;delay_us(50); RB0_bit =0;
  RB1_bit =rs;
  RB0_bit =1;delay_us(50); RB0_bit =0;
 for(i=0;i<4;i++){
 if((nyb & 0x08) != 0)
  RB1_bit =1;
 else
  RB1_bit =0;
  RB0_bit =1;delay_us(50); RB0_bit =0;
 nyb=nyb<<1;
 }
 e_togg();
}

void LCD_String_xy (char row, char pos, char *str)
{
 short i=0;
 switch(row){
 case 1:
 lcd_cmd(0x80);
 break;
 case 2:
 lcd_cmd(0xC0);
 break;
 case 3:
 lcd_cmd(0x94);
 break;
 case 4:
 lcd_cmd(0xD4);
 break;
 }

 for(i=1; i<pos; i++){
 lcd_char(32);
 }
 while(*str)
{
 lcd_char(*str);
 str++;
}

return;
}

void LCD_Char_xy (char row, char pos, char ch)
{

 if((pos-1) == 0) lcd_cmd(0x80 | (row-1));
 else lcd_cmd(0x80 | 0x40 | (row-1));

 lcd_char(ch);

}
void lcd_init(void)
{
 delay_ms(20);
 lcd_nybble(0x03,0);
 delay_ms(5);
 e_togg();
 delay_us(160);
 e_togg();
 delay_us(160);
 lcd_nybble(0x02,0);
 delay_us(160);
 lcd_cmd(0x28);
 delay_us(160);
 lcd_cmd(0x10);
 delay_us(160);
 lcd_cmd(0x06);
 delay_us(160);
 lcd_cmd(0x01);
 delay_us(160);
 Lcd_cmd( (0x08 | 0x04) );

}

void e_togg(void)
{
  RB1_bit =1;
 delay_us(50);
  RB1_bit =0;
}
